<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): /home/mohamed/code/tigl/src/app/tiglAppSSSP.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_ff4b04dd53616468f2d812c0c78deef9.html">app</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglAppSSSP.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglAppSSSP_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLAPPSSSP_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLAPPSSSP_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCombiner_8hpp.html">tiglAPICombiner.hpp</a>&quot;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment"> * GLOBAL DEFINITIONS</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"> * SSSPInfo class</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classSSSPInfo.html">   74</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSSSPInfo.html">SSSPInfo</a> {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment">    * Attributes</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#aa1472cb5d334e6889b81dc43df5f4a4b">   82</a></span>&#160;   uint_fast32_t <a class="code" href="classSSSPInfo.html#aa1472cb5d334e6889b81dc43df5f4a4b">parent</a>;</div>
<div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">   84</a></span>&#160;   <span class="keywordtype">double</span> <a class="code" href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">distance</a>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">    * Operator definitions</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#a71bc8ffaeee81678d5bd250d7393b464">   99</a></span>&#160;   <span class="keywordtype">double</span> operator -(T &amp;ref) {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;      <span class="keywordflow">return</span> ref.distance - distance;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   }</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#a0a457531c72a49329752604727248b0b">  109</a></span>&#160;   <span class="keywordtype">double</span> operator *(T &amp;ref) {</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;      <span class="keywordflow">return</span> ref.distance * distance;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;   }</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#aeb53a1de5ee43db3f11c2ea7d8504a21">  119</a></span>&#160;   <span class="keywordtype">double</span> operator +(T &amp;ref) {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;      <span class="keywordflow">return</span> ref.distance + distance;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;   }</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#a29a2110c66783d0589783d5f1fabe913">  128</a></span>&#160;   <span class="keywordtype">bool</span> operator &lt;(<a class="code" href="classSSSPInfo.html">SSSPInfo</a> &amp;ref) {</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;      <span class="keywordflow">return</span> distance &lt; ref.<a class="code" href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">distance</a>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;   }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#a7a50243bb874e6db536fce96e661034d">  137</a></span>&#160;   <span class="keywordtype">bool</span> operator &gt;(<a class="code" href="classSSSPInfo.html">SSSPInfo</a> &amp;ref) {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;      <span class="keywordflow">return</span> distance &gt; ref.<a class="code" href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">distance</a>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   }</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00146"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#a0c60f9384be7ff2f96f8c97d2860f8e1">  146</a></span>&#160;   <a class="code" href="classSSSPInfo.html">SSSPInfo</a> &amp; operator +=(<a class="code" href="classSSSPInfo.html">SSSPInfo</a> &amp;ref) {</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      distance += ref.<a class="code" href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">distance</a>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;      <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   }</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="classSSSPInfo.html#a4a3992ca87d6cbe746ce775cae614504">  157</a></span>&#160;   <span class="keywordtype">void</span> operator =(T distanceVal) {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      distance = distanceVal;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;   }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;};</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="tiglAppSSSP_8hpp.html#ad74f827b043d496aece3c9d7bc9b933b">  167</a></span>&#160;ostream&amp; <a class="code" href="tiglAppSSSP_8hpp.html#ad74f827b043d496aece3c9d7bc9b933b">operator&lt;&lt;</a>(ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classSSSPInfo.html">SSSPInfo</a>&amp; x) {</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;   os &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; x.<a class="code" href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">distance</a> &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; x.<a class="code" href="classSSSPInfo.html#aa1472cb5d334e6889b81dc43df5f4a4b">parent</a> &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;   <span class="keywordflow">return</span> os;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;}</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment"> * SSSPVertex class</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType = <span class="keywordtype">char</span>, <span class="keyword">typename</span> EdgeType = TIGLContainersEdgeBase&lt;u<span class="keywordtype">int</span>_fast32_t&gt; &gt;</div>
<div class="line"><a name="l00195"></a><span class="lineno"><a class="line" href="classVertexSSSP.html">  195</a></span>&#160;<span class="keyword">class </span><a class="code" href="classVertexSSSP.html">SSSPVertex</a>: <span class="keyword">public</span> <a class="code" href="classVertex.html">Vertex</a>&lt;DataType, SSSPInfo, EdgeType, uint_fast32_t,</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;      uint_fast32_t, DblMessage&gt; {</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertex.html">Vertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>,</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;         uint_fast32_t, uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;::MESSAGE_BUF_TYPE MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertex.html">Vertex</a>&lt;DataType, <a class="code" href="classSSSPInfo.html">SSSPInfo</a>, EdgeType, uint_fast32_t,</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;         uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00219"></a><span class="lineno"><a class="line" href="classVertexSSSP.html#a3ff4a47ab6299eaa8f4f053bdf097b16">  219</a></span>&#160;   <a class="code" href="classVertexSSSP.html#a3ff4a47ab6299eaa8f4f053bdf097b16">SSSPVertex</a>(uint_fast32_t key) :</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;         <a class="code" href="classVertex.html">Vertex</a>&lt;DataType, <a class="code" href="classSSSPInfo.html">SSSPInfo</a>, EdgeType, uint_fast32_t, uint_fast32_t,</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;               <a class="code" href="classMessage.html">DblMessage</a>&gt;(key, false, false) {</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;   }</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;   ~<a class="code" href="classVertexSSSP.html">SSSPVertex</a>() {</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;   }</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="comment">    * class methods</span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00244"></a><span class="lineno"><a class="line" href="classVertexSSSP.html#a8ddae43ff3bf8a7a8d84be2660fb79c4">  244</a></span>&#160;   uint_fast32_t <a class="code" href="classVertexSSSP.html#a8ddae43ff3bf8a7a8d84be2660fb79c4">compute</a>(MESSAGE_BUF_TYPE *pIn,</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;         vector&lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut, uint_fast32_t numMessages) {</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;      uint_fast32_t t = this-&gt;aggregateInfoPtr-&gt;getNumSS();</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; 1)</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;!!! Warning PregelSSSP compute: numMessages(&quot;</span> &lt;&lt; this-&gt;getId()</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;               &lt;&lt; <span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; numMessages &lt;&lt; endl; <span class="comment">//cout&lt;&lt;&quot;!!! Warning : numMessages(&quot; &lt;&lt; this-&gt;getId() &lt;&lt; &quot;) = &quot; &lt;&lt; pIn-&gt;size() &lt;&lt; endl;</span></div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; pIn-&gt;size())</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;         cout</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;               &lt;&lt; <span class="stringliteral">&quot;!!! Warning PregelSSSP compute: numMessages is bigger than buffer size&quot;</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;               &lt;&lt; endl;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;      vector&lt;DblMessage&gt;::iterator itm = pIn-&gt;begin();</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;      <span class="keywordtype">double</span> newDistance = itm-&gt;getContent();</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;      <span class="keywordtype">double</span> newParent = itm-&gt;getSender();</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; 1) {</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;         <span class="keywordflow">for</span> (uint_fast32_t loopCount = 0; loopCount &lt; numMessages; loopCount++) <span class="comment">//itm != pIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;               {</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            ++itm;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            <span class="keywordflow">if</span> (newDistance &gt; itm-&gt;getContent()) {</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;               newDistance = itm-&gt;getContent();</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;               newParent = itm-&gt;getSender();</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            }</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;         }</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;      }</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;      uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;      <span class="keywordflow">if</span> (newDistance &lt; this-&gt;algData.distance) <span class="comment">// or visited before but we have bettern score</span></div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            {</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;         this-&gt;algData.distance = newDistance;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;         this-&gt;algData.parent = newParent;</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;         <span class="comment">// now sending message to all children</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;         <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator();</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;               ite != this-&gt;getEndOutEdgeIterator(); ++ite) {</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            <span class="keywordflow">if</span> (dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;               <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="keywordtype">double</span> messageVal =</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;                  ite-&gt;hasVal() ?</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;                        newDistance + ite-&gt;getData() : newDistance + 1;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;            <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            numOutMessages++;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;         }</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;      }</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;      <span class="keywordflow">if</span> (t &gt; 1</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            &amp;&amp; this-&gt;algData.distance</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;                  &lt;= (this-&gt;aggregateInfoPtr-&gt;getPastMinActiveAlgData()).distance) {</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;         this-&gt;vote_to_halt();</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;      }</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;      <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;   } <span class="comment">// end of compute</span></div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00316"></a><span class="lineno"><a class="line" href="classVertexSSSP.html#a449b1d5a6acb40e3e439c65d76fb598f">  316</a></span>&#160;   uint_fast32_t <a class="code" href="classVertexSSSP.html#a449b1d5a6acb40e3e439c65d76fb598f">init</a>(uint_fast32_t *src,</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;         vector&lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut) {</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;      <span class="keywordflow">if</span> (this-&gt;<span class="keywordtype">id</span> == *src) {</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;         this-&gt;algData.distance = 0;</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;         this-&gt;algData.parent = *src;</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;         <span class="comment">// now sending messages to children nodes to the act</span></div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;         uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;         <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator();</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;               ite != this-&gt;getEndOutEdgeIterator(); ++ite) {</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;            uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;            <span class="keywordflow">if</span> (dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;               <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            <span class="keywordtype">double</span> messageVal = ite-&gt;hasVal() ? ite-&gt;getData() : 1;</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;            <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;            pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;            numOutMessages++;</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;         }</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;         this-&gt;vote_to_halt();</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;         <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;      }</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;         this-&gt;algData.distance = BIG_DBL_NUMBER;</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;         this-&gt;algData.parent = UNDEFINED_NODE;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;         this-&gt;activate();</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;         <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;      }</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;   }</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;};</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;<span class="comment"> * SSSPCombiner class</span></div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00373"></a><span class="lineno"><a class="line" href="classtiglCombinerSSSP.html">  373</a></span>&#160;<span class="keyword">class </span><a class="code" href="classtiglCombinerSSSP.html">SSSPCombiner</a>: <span class="keyword">public</span> <a class="code" href="classtiglCombiner.html">tiglCombiner</a>&lt;DblMessage&gt; {</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;DblMessage&gt;::iterator MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;   <a class="code" href="classtiglCombinerSSSP.html">SSSPCombiner</a>() {</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;   }</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;   ~<a class="code" href="classtiglCombinerSSSP.html">SSSPCombiner</a>() {</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;   }</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;<span class="comment">    * class methods</span></div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00408"></a><span class="lineno"><a class="line" href="classtiglCombinerSSSP.html#aead14a25e606fea33efdea80b6a972e4">  408</a></span>&#160;   uint_fast32_t <a class="code" href="classtiglCombinerSSSP.html#aead14a25e606fea33efdea80b6a972e4">combineMessages</a>(MESSAGE_ITERATOR itIn,</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;         uint_fast32_t numMessages, MESSAGE_ITERATOR itOut) {</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;      <span class="keywordflow">return</span> minCombineMessages(itIn, numMessages, itOut);</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;   }</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00421"></a><span class="lineno"><a class="line" href="classtiglCombinerSSSP.html#ae4a3769a35315ba8e167dbff633de247">  421</a></span>&#160;   uint_fast32_t <a class="code" href="classtiglCombinerSSSP.html#ae4a3769a35315ba8e167dbff633de247">combineMessages</a>(<a class="code" href="classMessage.html">DblMessage</a> &amp; newMessage,</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;         MESSAGE_ITERATOR itOut) {</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;      <span class="keywordflow">return</span> minCombineMessages(newMessage, itOut);</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;   }</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;};</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLAPPSSSP_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classtiglCombiner_html"><div class="ttname"><a href="classtiglCombiner.html">tiglCombiner</a></div><div class="ttdoc">pure combiner class for the TIGL engine </div><div class="ttdef"><b>Definition:</b> tiglAPICombiner.hpp:68</div></div>
<div class="ttc" id="tiglAppSSSP_8hpp_html_ad74f827b043d496aece3c9d7bc9b933b"><div class="ttname"><a href="tiglAppSSSP_8hpp.html#ad74f827b043d496aece3c9d7bc9b933b">operator&lt;&lt;</a></div><div class="ttdeci">ostream &amp; operator&lt;&lt;(ostream &amp;os, const SSSPInfo &amp;x)</div><div class="ttdoc">prints the algorithm field to stdout </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:167</div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdoc">core data message class definition </div><div class="ttdef"><b>Definition:</b> tiglAPIMessage.hpp:69</div></div>
<div class="ttc" id="classVertexSSSP_html_a8ddae43ff3bf8a7a8d84be2660fb79c4"><div class="ttname"><a href="classVertexSSSP.html#a8ddae43ff3bf8a7a8d84be2660fb79c4">SSSPVertex::compute</a></div><div class="ttdeci">uint_fast32_t compute(MESSAGE_BUF_TYPE *pIn, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut, uint_fast32_t numMessages)</div><div class="ttdoc">customized compute function </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:244</div></div>
<div class="ttc" id="tiglMessage_8hpp_html"><div class="ttname"><a href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a></div></div>
<div class="ttc" id="classSSSPInfo_html_ae3fdd56480d5c6fe95984fa25bef2f1f"><div class="ttname"><a href="classSSSPInfo.html#ae3fdd56480d5c6fe95984fa25bef2f1f">SSSPInfo::distance</a></div><div class="ttdeci">double distance</div><div class="ttdoc">distance to the source </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:84</div></div>
<div class="ttc" id="classtiglCombinerSSSP_html"><div class="ttname"><a href="classtiglCombinerSSSP.html">SSSPCombiner</a></div><div class="ttdoc">Combiner class for the SSSP algorithm. </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:373</div></div>
<div class="ttc" id="classVertexSSSP_html_a3ff4a47ab6299eaa8f4f053bdf097b16"><div class="ttname"><a href="classVertexSSSP.html#a3ff4a47ab6299eaa8f4f053bdf097b16">SSSPVertex::SSSPVertex</a></div><div class="ttdeci">SSSPVertex(uint_fast32_t key)</div><div class="ttdoc">constructor customizes Vertex by disabling vertex processing in the absence of messages ...</div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:219</div></div>
<div class="ttc" id="classtiglCombinerSSSP_html_ae4a3769a35315ba8e167dbff633de247"><div class="ttname"><a href="classtiglCombinerSSSP.html#ae4a3769a35315ba8e167dbff633de247">SSSPCombiner::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(DblMessage &amp;newMessage, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">overloaded customized combine function that combines a single message </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:421</div></div>
<div class="ttc" id="tiglCombiner_8hpp_html"><div class="ttname"><a href="tiglCombiner_8hpp.html">tiglAPICombiner.hpp</a></div></div>
<div class="ttc" id="tiglVertex_8hpp_html"><div class="ttname"><a href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a></div></div>
<div class="ttc" id="classVertexSSSP_html_a449b1d5a6acb40e3e439c65d76fb598f"><div class="ttname"><a href="classVertexSSSP.html#a449b1d5a6acb40e3e439c65d76fb598f">SSSPVertex::init</a></div><div class="ttdeci">uint_fast32_t init(uint_fast32_t *src, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut)</div><div class="ttdoc">customized init function </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:316</div></div>
<div class="ttc" id="classtiglCombinerSSSP_html_aead14a25e606fea33efdea80b6a972e4"><div class="ttname"><a href="classtiglCombinerSSSP.html#aead14a25e606fea33efdea80b6a972e4">SSSPCombiner::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function the combines a set of messages that calls the generic minimum combine ...</div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:408</div></div>
<div class="ttc" id="classVertexSSSP_html"><div class="ttname"><a href="classVertexSSSP.html">SSSPVertex</a></div><div class="ttdoc">Customized Vertex class for the Single Source Shortest Path using the Dijkstra Algorithm. </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:195</div></div>
<div class="ttc" id="classSSSPInfo_html"><div class="ttname"><a href="classSSSPInfo.html">SSSPInfo</a></div><div class="ttdoc">Defines the algorithm data field of the customized vertex class of the SSSP algorithm. </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:74</div></div>
<div class="ttc" id="classVertex_html"><div class="ttname"><a href="classVertex.html">Vertex</a></div><div class="ttdoc">core vertex class for the TIGL Engine (with only output edge buffer). </div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:88</div></div>
<div class="ttc" id="classSSSPInfo_html_aa1472cb5d334e6889b81dc43df5f4a4b"><div class="ttname"><a href="classSSSPInfo.html#aa1472cb5d334e6889b81dc43df5f4a4b">SSSPInfo::parent</a></div><div class="ttdeci">uint_fast32_t parent</div><div class="ttdoc">parent node in the shortest path </div><div class="ttdef"><b>Definition:</b> tiglAppSSSP.hpp:82</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Feb 25 2015 13:02:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
